/* Voorbeeldcode behorende bij het college "Programmeertechnieken",
 * LIACS, Universiteit Leiden.
 */
#include <iostream>

namespace mijnruimte {
  void zegHallo(void)
  {
    std::cout << "hallo daar" << std::endl;
  }

  static int A = 13;
}

int main(void)
{
  /* De compiler kan geen functie zegHallo en variabele A vinden,
   * want er wordt standaard niet in namespaces gezocht.
   */
  //zegHallo();  // Fout!
  //std::cout << A << std::endl; // Fout!

  /* In dit geval specificeren we de namespace als deel van de identifier. */
  mijnruimte::zegHallo();
  std::cout << mijnruimte::A << std::endl; // Fout!

  /* Hiermee laten we de compiler standaard in de namespace mijnruimte
   * zoeken.
   */
  using namespace mijnruimte;
  zegHallo();

  return 0;
}
